define(["exports","./css-parse.js","./style-settings.js","./style-transformer.js","./style-util.js","./common-regex.js","./style-info.js"],function(_exports,_cssParse,_styleSettings,_styleTransformer,StyleUtil,RX,_styleInfo){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.default=void 0;_styleTransformer=babelHelpers.interopRequireDefault(_styleTransformer);StyleUtil=babelHelpers.interopRequireWildcard(StyleUtil);RX=babelHelpers.interopRequireWildcard(RX);_styleInfo=babelHelpers.interopRequireDefault(_styleInfo);var matchesSelector=function(selector){var method=this.matches||this.matchesSelector||this.mozMatchesSelector||this.msMatchesSelector||this.oMatchesSelector||this.webkitMatchesSelector;return method&&method.call(this,selector)},IS_IE=navigator.userAgent.match("Trident"),XSCOPE_NAME="x-scope",StyleProperties=function(){function StyleProperties(){babelHelpers.classCallCheck(this,StyleProperties)}babelHelpers.createClass(StyleProperties,[{key:"decorateStyles",value:function decorateStyles(rules){var self=this,props={},keyframes=[],ruleIndex=0;StyleUtil.forEachRule(rules,function(rule){self.decorateRule(rule);rule.index=ruleIndex++;self.collectPropertiesInCssText(rule.propertyInfo.cssText,props)},function(rule){keyframes.push(rule)});rules._keyframes=keyframes;var names=[];for(var i in props){names.push(i)}return names}},{key:"decorateRule",value:function decorateRule(rule){if(rule.propertyInfo){return rule.propertyInfo}var info={},properties={},hasProperties=this.collectProperties(rule,properties);if(hasProperties){info.properties=properties;rule.rules=null}info.cssText=this.collectCssText(rule);rule.propertyInfo=info;return info}},{key:"collectProperties",value:function collectProperties(rule,properties){var info=rule.propertyInfo;if(info){if(info.properties){Object.assign(properties,info.properties);return!0}}else{var m,rx=RX.VAR_ASSIGN,cssText=rule.parsedCssText,value,any;while(m=rx.exec(cssText)){value=(m[2]||m[3]).trim();if("inherit"!==value||"unset"!==value){properties[m[1].trim()]=value}any=!0}return any}}},{key:"collectCssText",value:function collectCssText(rule){return this.collectConsumingCssText(rule.parsedCssText)}},{key:"collectConsumingCssText",value:function collectConsumingCssText(cssText){return cssText.replace(RX.BRACKETED,"").replace(RX.VAR_ASSIGN,"")}},{key:"collectPropertiesInCssText",value:function collectPropertiesInCssText(cssText,props){var m;while(m=RX.VAR_CONSUMED.exec(cssText)){var name=m[1];if(":"!==m[2]){props[name]=!0}}}},{key:"reify",value:function reify(props){for(var names=Object.getOwnPropertyNames(props),i=0,n;i<names.length;i++){n=names[i];props[n]=this.valueForProperty(props[n],props)}}},{key:"valueForProperty",value:function valueForProperty(property,props){if(property){if(0<=property.indexOf(";")){property=this.valueForProperties(property,props)}else{var self=this;property=StyleUtil.processVariableAndFallback(property,function fn(prefix,value,fallback,suffix){if(!value){return prefix+suffix}var propertyValue=self.valueForProperty(props[value],props);if(!propertyValue||"initial"===propertyValue){propertyValue=self.valueForProperty(props[fallback]||fallback,props)||fallback}else if("apply-shim-inherit"===propertyValue){propertyValue="inherit"}return prefix+(propertyValue||"")+suffix})}}return property&&property.trim()||""}},{key:"valueForProperties",value:function valueForProperties(property,props){for(var parts=property.split(";"),i=0,p,m;i<parts.length;i++){if(p=parts[i]){RX.MIXIN_MATCH.lastIndex=0;m=RX.MIXIN_MATCH.exec(p);if(m){p=this.valueForProperty(props[m[1]],props)}else{var colon=p.indexOf(":");if(-1!==colon){var pp=p.substring(colon);pp=pp.trim();pp=this.valueForProperty(pp,props)||pp;p=p.substring(0,colon)+pp}}parts[i]=p&&p.lastIndexOf(";")===p.length-1?p.slice(0,-1):p||""}}return parts.join(";")}},{key:"applyProperties",value:function applyProperties(rule,props){var output="";if(!rule.propertyInfo){this.decorateRule(rule)}if(rule.propertyInfo.cssText){output=this.valueForProperties(rule.propertyInfo.cssText,props)}rule.cssText=output}},{key:"applyKeyframeTransforms",value:function applyKeyframeTransforms(rule,keyframeTransforms){var input=rule.cssText,output=rule.cssText;if(null==rule.hasAnimations){rule.hasAnimations=RX.ANIMATION_MATCH.test(input)}if(rule.hasAnimations){var transform;if(null==rule.keyframeNamesToTransform){rule.keyframeNamesToTransform=[];for(var keyframe in keyframeTransforms){transform=keyframeTransforms[keyframe];output=transform(input);if(input!==output){input=output;rule.keyframeNamesToTransform.push(keyframe)}}}else{for(var i=0;i<rule.keyframeNamesToTransform.length;++i){transform=keyframeTransforms[rule.keyframeNamesToTransform[i]];input=transform(input)}output=input}}rule.cssText=output}},{key:"propertyDataFromStyles",value:function propertyDataFromStyles(rules,element){var props={},self=this,o=[];StyleUtil.forEachRule(rules,function(rule){if(!rule.propertyInfo){self.decorateRule(rule)}var selectorToMatch=rule.transformedSelector||rule.parsedSelector;if(element&&rule.propertyInfo.properties&&selectorToMatch){if(matchesSelector.call(element,selectorToMatch)){self.collectProperties(rule,props);addToBitMask(rule.index,o)}}},null,!0);return{properties:props,key:o}}},{key:"whenHostOrRootRule",value:function whenHostOrRootRule(scope,rule,cssBuild,callback){if(!rule.propertyInfo){this.decorateRule(rule)}if(!rule.propertyInfo.properties){return}var _StyleUtil$getIsExten=StyleUtil.getIsExtends(scope),is=_StyleUtil$getIsExten.is,typeExtension=_StyleUtil$getIsExten.typeExtension,hostScope=is?_styleTransformer.default._calcHostScope(is,typeExtension):"html",parsedSelector=rule.parsedSelector,isRoot=":host > *"===parsedSelector||"html"===parsedSelector,isHost=0===parsedSelector.indexOf(":host")&&!isRoot;if("shady"===cssBuild){isRoot=parsedSelector===hostScope+" > *."+hostScope||-1!==parsedSelector.indexOf("html");isHost=!isRoot&&0===parsedSelector.indexOf(hostScope)}if("shadow"===cssBuild){isRoot=":host > *"===parsedSelector||"html"===parsedSelector;isHost=isHost&&!isRoot}if(!isRoot&&!isHost){return}var selectorToMatch=hostScope;if(isHost){if(!rule.transformedSelector){rule.transformedSelector=_styleTransformer.default._transformRuleCss(rule,_styleTransformer.default._transformComplexSelector,_styleTransformer.default._calcElementScope(is),hostScope)}selectorToMatch=rule.transformedSelector||hostScope}callback({selector:selectorToMatch,isHost:isHost,isRoot:isRoot})}},{key:"hostAndRootPropertiesForScope",value:function hostAndRootPropertiesForScope(scope,rules){var hostProps={},rootProps={},self=this,cssBuild=rules&&rules.__cssBuild;StyleUtil.forEachRule(rules,function(rule){self.whenHostOrRootRule(scope,rule,cssBuild,function(info){var element=scope._element||scope;if(matchesSelector.call(element,info.selector)){if(info.isHost){self.collectProperties(rule,hostProps)}else{self.collectProperties(rule,rootProps)}}})},null,!0);return{rootProps:rootProps,hostProps:hostProps}}},{key:"transformStyles",value:function transformStyles(element,properties,scopeSelector){var self=this,_StyleUtil$getIsExten2=StyleUtil.getIsExtends(element),is=_StyleUtil$getIsExten2.is,typeExtension=_StyleUtil$getIsExten2.typeExtension,hostSelector=_styleTransformer.default._calcHostScope(is,typeExtension),rxHostSelector=element.extends?"\\"+hostSelector.slice(0,-1)+"\\]":hostSelector,hostRx=new RegExp(RX.HOST_PREFIX+rxHostSelector+RX.HOST_SUFFIX),rules=_styleInfo.default.get(element).styleRules,keyframeTransforms=this._elementKeyframeTransforms(element,rules,scopeSelector);return _styleTransformer.default.elementStyles(element,rules,function(rule){self.applyProperties(rule,properties);if(!_styleSettings.nativeShadow&&!StyleUtil.isKeyframesSelector(rule)&&rule.cssText){self.applyKeyframeTransforms(rule,keyframeTransforms);self._scopeSelector(rule,hostRx,hostSelector,scopeSelector)}})}},{key:"_elementKeyframeTransforms",value:function _elementKeyframeTransforms(element,rules,scopeSelector){var keyframesRules=rules._keyframes,keyframeTransforms={};if(!_styleSettings.nativeShadow&&keyframesRules){for(var i=0,keyframesRule=keyframesRules[i];i<keyframesRules.length;keyframesRule=keyframesRules[++i]){this._scopeKeyframes(keyframesRule,scopeSelector);keyframeTransforms[keyframesRule.keyframesName]=this._keyframesRuleTransformer(keyframesRule)}}return keyframeTransforms}},{key:"_keyframesRuleTransformer",value:function _keyframesRuleTransformer(keyframesRule){return function(cssText){return cssText.replace(keyframesRule.keyframesNameRx,keyframesRule.transformedKeyframesName)}}},{key:"_scopeKeyframes",value:function _scopeKeyframes(rule,scopeId){rule.keyframesNameRx=new RegExp("\\b".concat(rule.keyframesName,"(?!\\B|-)"),"g");rule.transformedKeyframesName=rule.keyframesName+"-"+scopeId;rule.transformedSelector=rule.transformedSelector||rule.selector;rule.selector=rule.transformedSelector.replace(rule.keyframesName,rule.transformedKeyframesName)}},{key:"_scopeSelector",value:function _scopeSelector(rule,hostRx,hostSelector,scopeId){rule.transformedSelector=rule.transformedSelector||rule.selector;for(var selector=rule.transformedSelector,scope="."+scopeId,parts=selector.split(","),i=0,l=parts.length,p;i<l&&(p=parts[i]);i++){parts[i]=p.match(hostRx)?p.replace(hostSelector,scope):scope+" "+p}rule.selector=parts.join(",")}},{key:"applyElementScopeSelector",value:function applyElementScopeSelector(element,selector,old){var c=element.getAttribute("class")||"",v=c;if(old){v=c.replace(new RegExp("\\s*"+XSCOPE_NAME+"\\s*"+old+"\\s*","g")," ")}v+=(v?" ":"")+XSCOPE_NAME+" "+selector;if(c!==v){StyleUtil.setElementClassRaw(element,v)}}},{key:"applyElementStyle",value:function applyElementStyle(element,properties,selector,style){var cssText=style?style.textContent||"":this.transformStyles(element,properties,selector),styleInfo=_styleInfo.default.get(element),s=styleInfo.customStyle;if(s&&!_styleSettings.nativeShadow&&s!==style){s._useCount--;if(0>=s._useCount&&s.parentNode){s.parentNode.removeChild(s)}}if(_styleSettings.nativeShadow){if(styleInfo.customStyle){styleInfo.customStyle.textContent=cssText;style=styleInfo.customStyle}else if(cssText){style=StyleUtil.applyCss(cssText,selector,element.shadowRoot,styleInfo.placeholder)}}else{if(!style){if(cssText){style=StyleUtil.applyCss(cssText,selector,null,styleInfo.placeholder)}}else if(!style.parentNode){if(IS_IE&&-1<cssText.indexOf("@media")){style.textContent=cssText}StyleUtil.applyStyle(style,null,styleInfo.placeholder)}}if(style){style._useCount=style._useCount||0;if(styleInfo.customStyle!=style){style._useCount++}styleInfo.customStyle=style}return style}},{key:"applyCustomStyle",value:function applyCustomStyle(style,properties){var rules=StyleUtil.rulesForStyle(style),self=this;style.textContent=StyleUtil.toCssText(rules,function(rule){var css=rule.cssText=rule.parsedCssText;if(rule.propertyInfo&&rule.propertyInfo.cssText){css=(0,_cssParse.removeCustomPropAssignment)(css);rule.cssText=self.valueForProperties(css,properties)}})}},{key:"XSCOPE_NAME",get:function get(){return XSCOPE_NAME}}]);return StyleProperties}();function addToBitMask(n,bits){var o=parseInt(n/32,10);bits[o]=(bits[o]||0)|1<<n%32}var _default=new StyleProperties;_exports.default=_default});