define(["exports","./css-parse.js","./style-util.js","./style-settings.js"],function(_exports,_cssParse,StyleUtil,_styleSettings){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.default=void 0;StyleUtil=babelHelpers.interopRequireWildcard(StyleUtil);var SCOPE_NAME="style-scope",StyleTransformer=function(){function StyleTransformer(){babelHelpers.classCallCheck(this,StyleTransformer)}babelHelpers.createClass(StyleTransformer,[{key:"dom",value:function dom(node,scope,shouldRemoveScope){var _this=this;if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,function fn(node){_this.element(node,scope||"",shouldRemoveScope)})}}},{key:"domAddScope",value:function domAddScope(node,scope){var _this2=this;if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,function fn(node){_this2.element(node,scope||"")})}}},{key:"_transformDom",value:function _transformDom(startNode,transformer){if(startNode.nodeType===Node.ELEMENT_NODE){transformer(startNode)}var c$="template"===startNode.localName?(startNode.content||startNode._content||startNode).childNodes:startNode.children||startNode.childNodes;if(c$){for(var i=0;i<c$.length;i++){this._transformDom(c$[i],transformer)}}}},{key:"element",value:function element(_element,scope,shouldRemoveScope){if(scope){if(_element.classList){if(shouldRemoveScope){_element.classList.remove(SCOPE_NAME);_element.classList.remove(scope)}else{_element.classList.add(SCOPE_NAME);_element.classList.add(scope)}}else if(_element.getAttribute){var c=_element.getAttribute("class");if(shouldRemoveScope){if(c){var newValue=c.replace(SCOPE_NAME,"").replace(scope,"");StyleUtil.setElementClassRaw(_element,newValue)}}else{var _newValue=(c?c+" ":"")+SCOPE_NAME+" "+scope;StyleUtil.setElementClassRaw(_element,_newValue)}}}}},{key:"domReplaceScope",value:function domReplaceScope(node,oldScope,newScope){var _this3=this;if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,function fn(node){_this3.element(node,oldScope,!0);_this3.element(node,newScope)})}}},{key:"domRemoveScope",value:function domRemoveScope(node,oldScope){var _this4=this;if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,function fn(node){_this4.element(node,oldScope||"",!0)})}}},{key:"elementStyles",value:function elementStyles(element,styleRules,callback){var cssBuildType=element.__cssBuild,cssText="";if(_styleSettings.nativeShadow||"shady"===cssBuildType){cssText=StyleUtil.toCssText(styleRules,callback)}else{var _StyleUtil$getIsExten=StyleUtil.getIsExtends(element),is=_StyleUtil$getIsExten.is,typeExtension=_StyleUtil$getIsExten.typeExtension;cssText=this.css(styleRules,is,typeExtension,callback)+"\n\n"}return cssText.trim()}},{key:"css",value:function css(rules,scope,ext,callback){var hostScope=this._calcHostScope(scope,ext);scope=this._calcElementScope(scope);var self=this;return StyleUtil.toCssText(rules,function(rule){if(!rule.isScoped){self.rule(rule,scope,hostScope);rule.isScoped=!0}if(callback){callback(rule,scope,hostScope)}})}},{key:"_calcElementScope",value:function _calcElementScope(scope){if(scope){return"."+scope}else{return""}}},{key:"_calcHostScope",value:function _calcHostScope(scope,ext){return ext?"[is=".concat(scope,"]"):scope}},{key:"rule",value:function rule(_rule,scope,hostScope){this._transformRule(_rule,this._transformComplexSelector,scope,hostScope)}},{key:"_transformRule",value:function _transformRule(rule,transformer,scope,hostScope){rule.selector=rule.transformedSelector=this._transformRuleCss(rule,transformer,scope,hostScope)}},{key:"_transformRuleCss",value:function _transformRuleCss(rule,transformer,scope,hostScope){var p$=rule.selector.split(COMPLEX_SELECTOR_SEP);if(!StyleUtil.isKeyframesSelector(rule)){for(var i=0,l=p$.length,p;i<l&&(p=p$[i]);i++){p$[i]=transformer.call(this,p,scope,hostScope)}}return p$.join(COMPLEX_SELECTOR_SEP)}},{key:"_twiddleNthPlus",value:function _twiddleNthPlus(selector){return selector.replace(NTH,function(m,type,inside){if(-1<inside.indexOf("+")){inside=inside.replace(/\+/g,"___")}else if(-1<inside.indexOf("___")){inside=inside.replace(/___/g,"+")}return":".concat(type,"(").concat(inside,")")})}},{key:"_transformComplexSelector",value:function _transformComplexSelector(selector,scope,hostScope){var _this5=this,stop=!1;selector=selector.trim();var isNth=NTH.test(selector);if(isNth){selector=selector.replace(NTH,function(m,type,inner){return":".concat(type,"(").concat(inner.replace(/\s/g,""),")")});selector=this._twiddleNthPlus(selector)}selector=selector.replace(SLOTTED_START,"".concat(HOST," $1"));selector=selector.replace(SIMPLE_SELECTOR_SEP,function(m,c,s){if(!stop){var info=_this5._transformCompoundSelector(s,c,scope,hostScope);stop=stop||info.stop;c=info.combinator;s=info.value}return c+s});if(isNth){selector=this._twiddleNthPlus(selector)}return selector}},{key:"_transformCompoundSelector",value:function _transformCompoundSelector(selector,combinator,scope,hostScope){var slottedIndex=selector.indexOf(SLOTTED);if(0<=selector.indexOf(HOST)){selector=this._transformHostSelector(selector,hostScope)}else if(0!==slottedIndex){selector=scope?this._transformSimpleSelector(selector,scope):selector}var slotted=!1;if(0<=slottedIndex){combinator="";slotted=!0}var stop;if(slotted){stop=!0;if(slotted){selector=selector.replace(SLOTTED_PAREN,function(m,paren){return" > ".concat(paren)})}}selector=selector.replace(DIR_PAREN,function(m,before,dir){return"[dir=\"".concat(dir,"\"] ").concat(before,", ").concat(before,"[dir=\"").concat(dir,"\"]")});return{value:selector,combinator:combinator,stop:stop}}},{key:"_transformSimpleSelector",value:function _transformSimpleSelector(selector,scope){var p$=selector.split(PSEUDO_PREFIX);p$[0]+=scope;return p$.join(PSEUDO_PREFIX)}},{key:"_transformHostSelector",value:function _transformHostSelector(selector,hostScope){var m=selector.match(HOST_PAREN),paren=m&&m[2].trim()||"";if(paren){if(!paren[0].match(SIMPLE_SELECTOR_PREFIX)){var typeSelector=paren.split(SIMPLE_SELECTOR_PREFIX)[0];if(typeSelector===hostScope){return paren}else{return"should_not_match"}}else{return selector.replace(HOST_PAREN,function(m,host,paren){return hostScope+paren})}}else{return selector.replace(HOST,hostScope)}}},{key:"documentRule",value:function documentRule(rule){rule.selector=rule.parsedSelector;this.normalizeRootSelector(rule);this._transformRule(rule,this._transformDocumentSelector)}},{key:"normalizeRootSelector",value:function normalizeRootSelector(rule){if(rule.selector===":root"){rule.selector="html"}}},{key:"_transformDocumentSelector",value:function _transformDocumentSelector(selector){return selector.match(SLOTTED)?this._transformComplexSelector(selector,SCOPE_DOC_SELECTOR):this._transformSimpleSelector(selector.trim(),SCOPE_DOC_SELECTOR)}},{key:"SCOPE_NAME",get:function get(){return SCOPE_NAME}}]);return StyleTransformer}(),NTH=/:(nth[-\w]+)\(([^)]+)\)/,SCOPE_DOC_SELECTOR=":not(.".concat(SCOPE_NAME,")"),COMPLEX_SELECTOR_SEP=",",SIMPLE_SELECTOR_SEP=/(^|[\s>+~]+)((?:\[.+?\]|[^\s>+~=[])+)/g,SIMPLE_SELECTOR_PREFIX=/[[.:#*]/,HOST=":host",SLOTTED="::slotted",SLOTTED_START=new RegExp("^(".concat(SLOTTED,")")),HOST_PAREN=/(:host)(?:\(((?:\([^)(]*\)|[^)(]*)+?)\))/,SLOTTED_PAREN=/(?:::slotted)(?:\(((?:\([^)(]*\)|[^)(]*)+?)\))/,DIR_PAREN=/(.*):dir\((?:(ltr|rtl))\)/,PSEUDO_PREFIX=":",_default=new StyleTransformer;_exports.default=_default});