define(["exports","./css-parse.js","./style-util.js","./style-settings.js"],function(_exports,_cssParse,StyleUtil,_styleSettings){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.default=void 0;StyleUtil=babelHelpers.interopRequireWildcard(StyleUtil);const SCOPE_NAME="style-scope";class StyleTransformer{get SCOPE_NAME(){return SCOPE_NAME}dom(node,scope,shouldRemoveScope){if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,node=>{this.element(node,scope||"",shouldRemoveScope)})}}domAddScope(node,scope){if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,node=>{this.element(node,scope||"")})}}_transformDom(startNode,transformer){if(startNode.nodeType===Node.ELEMENT_NODE){transformer(startNode)}let c$="template"===startNode.localName?(startNode.content||startNode._content||startNode).childNodes:startNode.children||startNode.childNodes;if(c$){for(let i=0;i<c$.length;i++){this._transformDom(c$[i],transformer)}}}element(element,scope,shouldRemoveScope){if(scope){if(element.classList){if(shouldRemoveScope){element.classList.remove(SCOPE_NAME);element.classList.remove(scope)}else{element.classList.add(SCOPE_NAME);element.classList.add(scope)}}else if(element.getAttribute){let c=element.getAttribute(CLASS);if(shouldRemoveScope){if(c){let newValue=c.replace(SCOPE_NAME,"").replace(scope,"");StyleUtil.setElementClassRaw(element,newValue)}}else{let newValue=(c?c+" ":"")+SCOPE_NAME+" "+scope;StyleUtil.setElementClassRaw(element,newValue)}}}}domReplaceScope(node,oldScope,newScope){if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,node=>{this.element(node,oldScope,!0);this.element(node,newScope)})}}domRemoveScope(node,oldScope){if(node.__styleScoped){node.__styleScoped=null}else{this._transformDom(node,node=>{this.element(node,oldScope||"",!0)})}}elementStyles(element,styleRules,callback){let cssBuildType=element.__cssBuild,cssText="";if(_styleSettings.nativeShadow||"shady"===cssBuildType){cssText=StyleUtil.toCssText(styleRules,callback)}else{let{is,typeExtension}=StyleUtil.getIsExtends(element);cssText=this.css(styleRules,is,typeExtension,callback)+"\n\n"}return cssText.trim()}css(rules,scope,ext,callback){let hostScope=this._calcHostScope(scope,ext);scope=this._calcElementScope(scope);let self=this;return StyleUtil.toCssText(rules,function(rule){if(!rule.isScoped){self.rule(rule,scope,hostScope);rule.isScoped=!0}if(callback){callback(rule,scope,hostScope)}})}_calcElementScope(scope){if(scope){return CSS_CLASS_PREFIX+scope}else{return""}}_calcHostScope(scope,ext){return ext?`[is=${scope}]`:scope}rule(rule,scope,hostScope){this._transformRule(rule,this._transformComplexSelector,scope,hostScope)}_transformRule(rule,transformer,scope,hostScope){rule.selector=rule.transformedSelector=this._transformRuleCss(rule,transformer,scope,hostScope)}_transformRuleCss(rule,transformer,scope,hostScope){let p$=rule.selector.split(COMPLEX_SELECTOR_SEP);if(!StyleUtil.isKeyframesSelector(rule)){for(let i=0,l=p$.length,p;i<l&&(p=p$[i]);i++){p$[i]=transformer.call(this,p,scope,hostScope)}}return p$.join(COMPLEX_SELECTOR_SEP)}_twiddleNthPlus(selector){return selector.replace(NTH,(m,type,inside)=>{if(-1<inside.indexOf("+")){inside=inside.replace(/\+/g,"___")}else if(-1<inside.indexOf("___")){inside=inside.replace(/___/g,"+")}return`:${type}(${inside})`})}_transformComplexSelector(selector,scope,hostScope){let stop=!1;selector=selector.trim();let isNth=NTH.test(selector);if(isNth){selector=selector.replace(NTH,(m,type,inner)=>`:${type}(${inner.replace(/\s/g,"")})`);selector=this._twiddleNthPlus(selector)}selector=selector.replace(SLOTTED_START,`${HOST} $1`);selector=selector.replace(SIMPLE_SELECTOR_SEP,(m,c,s)=>{if(!stop){let info=this._transformCompoundSelector(s,c,scope,hostScope);stop=stop||info.stop;c=info.combinator;s=info.value}return c+s});if(isNth){selector=this._twiddleNthPlus(selector)}return selector}_transformCompoundSelector(selector,combinator,scope,hostScope){let slottedIndex=selector.indexOf(SLOTTED);if(0<=selector.indexOf(HOST)){selector=this._transformHostSelector(selector,hostScope)}else if(0!==slottedIndex){selector=scope?this._transformSimpleSelector(selector,scope):selector}let slotted=!1;if(0<=slottedIndex){combinator="";slotted=!0}let stop;if(slotted){stop=!0;if(slotted){selector=selector.replace(SLOTTED_PAREN,(m,paren)=>` > ${paren}`)}}selector=selector.replace(DIR_PAREN,(m,before,dir)=>`[dir="${dir}"] ${before}, ${before}[dir="${dir}"]`);return{value:selector,combinator,stop}}_transformSimpleSelector(selector,scope){let p$=selector.split(PSEUDO_PREFIX);p$[0]+=scope;return p$.join(PSEUDO_PREFIX)}_transformHostSelector(selector,hostScope){let m=selector.match(HOST_PAREN),paren=m&&m[2].trim()||"";if(paren){if(!paren[0].match(SIMPLE_SELECTOR_PREFIX)){let typeSelector=paren.split(SIMPLE_SELECTOR_PREFIX)[0];if(typeSelector===hostScope){return paren}else{return SELECTOR_NO_MATCH}}else{return selector.replace(HOST_PAREN,function(m,host,paren){return hostScope+paren})}}else{return selector.replace(HOST,hostScope)}}documentRule(rule){rule.selector=rule.parsedSelector;this.normalizeRootSelector(rule);this._transformRule(rule,this._transformDocumentSelector)}normalizeRootSelector(rule){if(rule.selector===ROOT){rule.selector="html"}}_transformDocumentSelector(selector){return selector.match(SLOTTED)?this._transformComplexSelector(selector,SCOPE_DOC_SELECTOR):this._transformSimpleSelector(selector.trim(),SCOPE_DOC_SELECTOR)}}let NTH=/:(nth[-\w]+)\(([^)]+)\)/,SCOPE_DOC_SELECTOR=`:not(.${SCOPE_NAME})`,COMPLEX_SELECTOR_SEP=",",SIMPLE_SELECTOR_SEP=/(^|[\s>+~]+)((?:\[.+?\]|[^\s>+~=[])+)/g,SIMPLE_SELECTOR_PREFIX=/[[.:#*]/,HOST=":host",ROOT=":root",SLOTTED="::slotted",SLOTTED_START=new RegExp(`^(${SLOTTED})`),HOST_PAREN=/(:host)(?:\(((?:\([^)(]*\)|[^)(]*)+?)\))/,SLOTTED_PAREN=/(?:::slotted)(?:\(((?:\([^)(]*\)|[^)(]*)+?)\))/,DIR_PAREN=/(.*):dir\((?:(ltr|rtl))\)/,CSS_CLASS_PREFIX=".",PSEUDO_PREFIX=":",CLASS="class",SELECTOR_NO_MATCH="should_not_match";var _default=new StyleTransformer;_exports.default=_default});